var itemGridManager = null,fillinDate="";
$(function () {
    initItemGrid();
    bindEvent();
});

function bindEvent() {
    fillinDate = $("#fillinDate").val();
}

function initItemGrid() {
    var toolbarOptions = UICtrl.getDefaultToolbarOptions({
        addHandler: function(){
            UICtrl.addGridRow(itemGridManager);
        },
        deleteHandler: function (){
            var _grid = UICtrl.getGridManager('#maingrid');
            DataUtil.delSelectedRows({
                action: 'sapQualityInfoRecordItem/deleteSapQualityInfoRecordItem.ajax',
                param: {},
                gridManager: _grid,
                idFieldName: 'id',
                onSuccess: function () {
                    reloadGrid();
                }
            });
        },
    });
        itemGridManager = UICtrl.grid('#maingrid', {
            columns: getGridColumns(),
            dataAction: 'server',
            url: web_app.name + '/sapQualityInfoRecordItem/querySapQualityInfoRecordItems.ajax',
            parms:{sapQualityInfoRecordId:Public.isNotBlank(getId())?getId():$("#tempId").val()},
            height: '98%',
            heightDiff: -4,
            sortName: 'id',
            sortOrder: 'asc',
            checkbox: true,
            usePager: true,
            rownumbers: true,
            enabledEdit: true,
            fixedCellHeight: true,
            selectRowButtonOnly: true,
            //autoApplyNextEditor:false,
            toolbar: toolbarOptions,
            onBeforeEdit: function (editParma) {
                if (Public.isBlank(editParma.record.grsrq) && (editParma.column.name=='grscertnr' || editParma.column.name=='grscertdatai')){
                    return false;
                }
                if (Public.isBlank(editParma.record.fscrq) && (editParma.column.name=='fsccertnr' || editParma.column.name=='fsccertdatai')){
                    return false;
                }

                return true;

            },
        }
    );
    UICtrl.setSearchAreaToggle(itemGridManager);
}

function getGridColumns() {
    var columns = [];
    columns = [
        {display: "质量信息记录号", name: "zqinfno", width: "300", align: "left", type: "string",

            //editor: {required: false, type: "text"}
        },
        {display: "工厂", name: "werksName", width: "200", align: "left", type: "string",
            editor: {
                required: true, type: "select",
                data: {
                    type: 'system',
                    name: "dictionary",
                    getParam: function (item) {
                        return {fieldName: "WERKS"}
                    },
                    back: {
                        WERKS: "werks",
                        NAME1: "werksName",
                    }
                },
            }
        },
        {display: "供应商", name: "lieferant", width: "200", align: "left", type: "string",
            editor: {required: true, type: "text"}
            // editor: {
            //     required: true, type: "select",
            //     data: {
            //         type: 'system',
            //         name: "dictionary",
            //         getParam: function (item) {
            //             return {fieldName: "LIFNR"}
            //         },
            //         back: {
            //             LIFNR: "lifnr",
            //             NAME1: "lifnrName",
            //         }
            //     },
            // }
        },
        {display: "物料编码", name: "matnr", width: "200", align: "left", type: "string",
            editor: {
                required: true, type: "select",
                data: {
                    type: 'system',
                    name: "sapMaterialSelect",
                    getParam: function (item) {
                        return {
                            filterValue:item.werks
                        }
                    },
                    back: {
                        MATNR: "matnr",
                        MAKTX: "maktx",
                        MATKL: "matkl",
                        WGBEZ: "matklName"
                    }
                },
            }
        },
        {display: "物料描述", name: "maktx", width: "300", align: "left", type: "string",
            editor: {required: true, type: "text"}
        },
        {display: "物料组", name: "matklName", width: "200", align: "left", type: "string",
            editor: {
                required: true, type: "select",
                data: {
                    type: 'system',
                    name: "dictionary",
                    getParam: function (item) {
                        return {
                            fieldName: "MATKL"
                        }
                    },
                    back: {
                        MATKL: "matkl",
                        WGBEZ: "matklName",
                    }
                },
            }
        },

        {display: "合格准入验证节点1", name: "zqavfn1", width: "200", align: "left", type: "string",
            //editor: {required: false, type: "text"}
        },
        {display: "节点1结论", name: "zvfnc1", width: "100", align: "left", type: "string",
            //editor: {type: 'text', }
        },
        {display: "合格准入验证节点2", name: "zqavfn2", width: "200", align: "left", type: "string",
            //editor: {required: false, type: "text"}
        },
        {display: "节点2结论", name: "zvfnc2", width: "100", align: "left", type: "string",
            //editor: {required: false, type: "text"}
        },
        {display: "合格准入验证节点3", name: "zqavfn3", width: "200", align: "left", type: "string",
            //editor: {required: false, type: "text"}
        },
        {display: "节点3结论", name: "zvfnc3", width: "100", align: "left", type: "string",
            //editor: {required: false, type: "text"}
        },
        // {display: "合格准入验证节点4", name: "zqavfn4", width: "200", align: "left", type: "string",
        //     editor: {type: 'text' }
        // },
        // {display: "节点4结论", name: "zvfnc4", width: "100", align: "left", type: "string",
        //     editor: {type: 'text'}
        // },
        {display: "打样单号码", name: "zspaufnr", width: "200", align: "left", type: "string",
            editor: {type: "text", required: false,}
        },
        {display: "GRSRQ", name: "grsrq", width: "100", align: "left", type: "string",
            editor: {
                type: 'dictionary',
                data: {name: 'grsrq'},
                textField: 'grsrqTextView',
                valueField: 'grsrq',
                required: true,
                render: function (item) {
                    return item.grsrqTextView;
                }
            },
        },
        {display: "GRS证书号", name: "grscertnr", width: "200", align: "left", type: "string",
            editor: {type: 'text'},
        },
        {display: "GRS证书到期日", name: "grscertdatai", width: "150", align: "left", type: "date",
            editor: {type: 'date'}
        },
        {display: "FSC认证要求", name: "fscrq", width: "200", align: "left", type: "string",
            editor: {
                type: 'dictionary',
                data: {name: 'grsrq'},
                textField: 'fscrqTextView',
                valueField: 'fscrq',
                required: true,
                render: function (item) {
                    return item.fscrqTextView;
                }
            },
        },
        {display: "FSC证书号", name: "fsccertnr", width: "200", align: "left", type: "string",
            editor: {type: "text"}
        },
        {display: "FSC证书到期日", name: "fsccertdatai", width: "150", minWidth: 60, type: "date", align: "center",
            editor: {type: "date"}
        },
        {display: "合格准入状态", name: "zqafst", width: "100", minWidth: 60, type: "string", align: "center",
            editor: {type: "text"}
        },
        {display: "合格有效期从", name: "zvdatab", width: "150", minWidth: 60, type: "date", align: "center",
            editor: {type: 'date'},
        },
        {display: "合格有效期到", name: "zvdatai", width: "150", minWidth: 60, type: "date", align: "center",
            editor: {type: "date"}
        },
        {display: "备注文本", name: "ztext", width: "120", align: "left", type: "string",
            editor: {type: 'text'}
        },
    ]
    return columns;
}

//获取数据保存的参数
function getExtendedData(processAction) {
    //回退、打回、转交时，不需要验证必填项是否已经填写；
    if (processAction == ProcessAction.BACK
        || processAction == ProcessAction.REPLENISH
        || processAction == ProcessAction.TRANSMIT) {
        //不验证
        $('#submitForm').attr('check', false);
    }
    var extendedData = {};
    var _grid = UICtrl.getGridManager('#maingrid');
    if (_grid) {
        var datas = DataUtil.getGridData({
            gridManager: _grid,
            isAllData: true
        });
        if (!datas) {
            return false;
        }
        if (Public.isNotBlank($("#tempId").val())){
            datas.forEach(data=>{
                data.id = "";
                data.sapQualityInfoRecordId=""
                data.zqinfno=""
                data.type=""
                data.message=""
                if (Public.isNotBlank(data.grsrq)){
                    if (Public.isBlank(data.grscertnr)){
                        Public.tip("GRS证书号不能为空")
                        return false
                    }
                    if (Public.isBlank(data.grscertdatai)){
                        Public.tip("GRS证书到期日不能为空")
                        return false
                    }
                }
                if (Public.isNotBlank(data.fscrq)){
                    if (Public.isBlank(data.fsccertnr)){
                        Public.tip("FSC证书号不能为空")
                        return false
                    }
                    if (Public.isBlank(data.fsccertdatai)){
                        Public.tip("FSC证书到期日不能为空")
                        return false
                    }
                }
            })
        }
        extendedData.items = Public.encodeJSONURI(datas);
    }
    return extendedData;
}

function getId() {
    return $('#id').val();
}

function setId(value) {
    $("#id").val(value);
    var _grid=UICtrl.getGridManager('#maingrid');
    _grid.options.parms.sapQualityInfoRecordId = value;
}

function reloadGrid() {
    itemGridManager.loadData();
}

function getGridData(){
    var _grid = UICtrl.getGridManager('#maingrid');
    var datas = DataUtil.getGridData({
        gridManager: _grid,
        isAllData: true
    });
    return datas;
}

